<?php
/* utf8-marker = äöüß */

/*
 * Remotecontent_XH
 *
 * @author Olaf Penschke
 * @version 1.1 (28.02.2018)
 * @link    http://olaf.penschke.net/
 * @license http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
================================================================================

olape

================================================================================

externe Inhalte in eine Seite einbinden
Aufruf mit:

======================================
html-Datei mit Authentifizierung einbinden
	{{{op_extern_content('https://domain.tld/userfiles/extern_content/datei.htm', '16-stelliges-AuthToken', 'fiktive_Browserkenneung', 'Art des Inhalts (txt, html, fullhtml', 'Wenn javaScript erhalten bleiben soll, dann js');}}}
		
		CURLOPT_USERAGENT, authtoken und IP der Webseite/des Server sind, für dieses Beispiel in "/userfiles/extern_content/.htaccess" als Regel für den Zugriff festgelegt.

======================================
	Druckausgabe von CMSimple einbinden (Urheberrechte beachten!!!)
		{{{op_extern_content('http://domain.tld/?IrgendeineSeite&print', '', '', 'fullhtml', 'js');}}}

	txt --> reine Textdatei
	html --> Boilerplate_XH Textblock
	fullhtml --> vollständige html-Datei (html, head, body, ...)

	js --> wenn gesetzt, wird JavaScript nicht gefiltert


================================================================================
*/

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
	die(
		'Plugin '. basename(dirname(__FILE__))
		. ' requires a newer version of the Pluginloader. No direct access.'
	);
}

//*********************************************************************************************
// dynamisches Menü unter Plugin

if(function_exists('XH_registerStandardPluginMenuItems')) {
	XH_registerStandardPluginMenuItems(true);
}
//*********************************************************************************************
if(XH_wantsPluginAdministration('remotecontent')) {
	$o .= print_plugin_admin('on');
	
// Menü in der Pluginkopfzeile

	if(($admin != 'plugin_main') && ($admin != ''))
	{
		$o .= plugin_admin_common($action, $admin, $plugin);
	}
//*********************************************************************************************
//*********************************************************************************************
$op_plugin_name = 'remotecontent_XH';
$op_plugin_version = '1.1';
$op_copyright = '2016 - ' . date('Y');
$op_cms_version_arr = array('1.6.10','1.7.0','1.7.1','1.7.2');
$op_php_version = '5.3';
//*********************************************************************************************
//*********************************************************************************************
	if($admin == '')	//Anzeige nur auf Startseite des Plugins
	{
		$o .= "\n" . '<h1>'
		   . ucfirst(str_replace('_', ' ', $plugin)) . '</h1>';

		$o .= "\n".'<p style="font-family: arial, sans-serif;"><b>Plugin "' . $op_plugin_name . '" for CMSimple_XH</b></p>
		<hr>
		<p style="font-family: arial, sans-serif;">Version: ' . $op_plugin_version . '</p>
		<p style="font-family: arial, sans-serif;">' . $op_plugin_name . ', Copyright © ' . $op_copyright  . ' <a target="_blank" href="http://olaf.penschke.net/?CMSimple_XH/Plugins">Olaf Penschke</a></p>
		<p> </p>
		<p><a target="_blank" href="http://olaf.penschke.net/?Kontakt&xh_mailform_subject=' . $op_plugin_name . '">' 
		. $plugin_tx['meta_tags_plus']['admin_contact'] . '</a></p>
		<p> </p>
		<p style="font-family: arial, sans-serif;"><b>' . $op_plugin_name . '</b>' . $plugin_tx['meta_tags_plus']['admin_licence'] . ' 
		<a target="_blank" href="http://www.gnu.de/documents/gpl.de.html">GPLv3</a></p>
		<hr>
		<p>Adapted for CMSimple_XH ' . $op_cms_version_arr[0] . ' - ' . end($op_cms_version_arr) . ' by <a target="_blank" href="http://www.cmsimple-xh.org/">cmsimple-xh.org</a></p>';

//*********************************************************************************************
// System check
//*********************************************************************************************
		$o .= '<h4>System check</h4>';
// cURL installiert / aktiviert
		$o .= '<ul style="list-style-type: none;">' . "\n";
		if (function_exists('curl_init')) {
				$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
				   . ' cURL &#x2192 is installed</li>' 
				   . "\n";
			} else {
				$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
				   . ' cURL &#x2192 is not installed</li>' 
				   . "\n";
			}
		$o .= '</ul>' . "\n";
// CMSimple_XH Version
		$op_cms_version_tmp = CMSIMPLE_XH_VERSION;
		$op_cms_version_tmp = str_replace(array('CMSimple_XH '), '', $op_cms_version_tmp);
		$o .= '<ul style="list-style-type: none;">' . "\n";
		if(in_array($op_cms_version_tmp, $op_cms_version_arr, true)) {
			$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
			   . CMSIMPLE_XH_VERSION 
			   . ' &#x2192 supported</li>' 
			   . "\n";
		} else {
			$o .= '<li><span style="color: #ffcc00; font-size: 20px">&#x2714 &#x263A </span>' 
			   . CMSIMPLE_XH_VERSION 
			   . ' &#x2192 I hope it is still supported. It was designed for ' 
			   . $op_cms_version_arr[0] 
			   . ' - ' 
			   . end($op_cms_version_arr) 
			   . '.</li>' 
			   . "\n";
		}
		$o .= '</ul>' . "\n";
// PHP Version
		$o .= '<ul style="list-style-type: none;">' . "\n";
		if (version_compare(phpversion(), $op_php_version, '<')) {
			$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>PHP: ' 
			   . phpversion() 
			   . ' &#x2192 not supported</li>' 
			   . "\n";
		} else {
			$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>PHP: ' 
			   . phpversion() 
			   . ' &#x2192 supported</li>' 
			   . "\n";
		}
		$o .= '</ul>' . "\n";
// Schreibrechte
		$op_filename_arr = array($pth['folder']['plugins'] . 'remotecontent/config/config.php', 
								 $pth['folder']['plugins'] . 'remotecontent/css/stylesheet.css', 
								 $pth['folder']['plugins'] . 'remotecontent/languages/' . $sl . '.php', 
								 $pth['folder']['plugins'] . 'remotecontent/config/', 
								 $pth['folder']['plugins'] . 'remotecontent/languages/', 
								 $pth['folder']['plugins'] . 'remotecontent/cache/');
		$o .= '<ul style="list-style-type: none;">' . "\n";
		foreach($op_filename_arr as $op_filename) {
			if (is_writable($op_filename)) {
				$o .= '<li><span style="color: #009966; font-size: 20px">&#x2714 &#x263A </span>' 
				   . $op_filename 
				   . ' &#x2192 writable</li>' 
				   . "\n";
			} else {
				$o .= '<li><span style="color: #ff0000; font-size: 20px">&#x2718 &#x2639 </span>' 
				   . $op_filename . ' &#x2192 not writable</li>' 
				   . "\n";
			}
		}
		$o .= '</ul>' . "\n";
	}

//*********************************************************************************************
// Cache Löschen

		if((isset($_GET['delete'])) && ($_GET['delete'] == 'cache')) {
			$op_del_cache_tmp= rtrim(remotecontent_listcache('small'), ',');
			$op_del_cache_tmp = explode(',', $op_del_cache_tmp);
			foreach($op_del_cache_tmp as $op_del_file_tmp) {
				if($op_del_file_tmp != '') {
					unlink($pth['folder']['plugins'] . 'remotecontent/cache/'. $op_del_file_tmp);
				}
			}
		}

//*********************************************************************************************
// Anzeige unter main --> Cache
		if($admin == 'plugin_main') {
			if(remotecontent_listcache('small')) {
				$o .= '<br><hr><br>';
				$o .= remotecontent_listcache('full');
				$o .= '<a class="recodelcache" href="?&remotecontent&admin=plugin_main&delete=cache">' . $plugin_tx['remotecontent']['del_cache'] . '</a>';
			}
		}

}

//*********************************************************************************************
// Cache auslesen
function remotecontent_listcache($listformat = '')
{
global $pth;

	$op_list_cache = '';
	$op_allfiles = scandir($pth['folder']['plugins'] . 'remotecontent/cache/');

	foreach($op_allfiles as $op_file_tmp) {
		if(($op_file_tmp != '.') 
		&& ($op_file_tmp != '..')) {
			if($listformat == 'full') {
				$op_list_cachetime = date('F d Y H:i:s', filemtime($pth['folder']['plugins'] . 'remotecontent/cache/' . $op_file_tmp));
				$op_list_cache .= $op_file_tmp . ' -- ' . $op_list_cachetime . '<br><br>' . "\n";
			} else {
				$op_list_cache .= $op_file_tmp . ',';
			}
		}
	}
return $op_list_cache;
}

?>